%define releasebase 1 
%define nbase1 mpich
%define modulepath /opt/Modules/modulefiles

#Use as deafults if no command line inputs
%define as_limulus 1
%define use_gnu4  1
# allow --with[out] <feature> at rpm command line build
# compiler
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
# package tag
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
# OMX or acient GM option
%{?_with_gm: %{expand: %%define as_gm 1}}
%{?_with_omx: %{expand: %%define as_omx 1}}
%{?_with_mx: %{expand: %%define as_mx 1}}

%if "1" == "%{as_omx}"
%define nbase %{nbase1}-omx
%define moduleconflicts %{nbase1} %{nbase1}-mx  %{nbase1}-gm openmpi
%else 
%if "1" == "%{as_mx}"
%define nbase %{nbase1}-mx
%define moduleconflicts %{nbase1} %{nbase1}-omx  %{nbase1}-gm openmpi
%else
%if "1" == "%{as_gm}"
%define nbase %{nbase1}-gm
%define moduleconflicts %{nbase1} %{nbase1}-omx  %{nbase1}-mx openmpi
%else
%define nbase %{nbase1}
%define moduleconflicts %{nbase1}-omx %{nbase1}-mx  %{nbase1}-gm openmpi
%endif 
%endif
%endif

%define prefixbase 	/opt/mpi

#pick the target
%if "1" == "%{as_basement}"
%define _prefix   %{prefixbase}/%{fullname}
%define moduleroot      %{prefixbase}/%{name}
%define _docdir         %{_prefix}/doc
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define _prefix %{afsroot}/%{afsarch}/%{prefixbase}/%{fullname}
%define moduleroot      %{afsroot}/%{afsarch}/%{prefixbase}/%{name}
%define  _defaultdocdir %{afsroot}/%{afsarch}/%{_usr}/share/doc
%define targetbase afs_%{afsarch}
%else
%define targetbase Limulus
%define _prefix         %{prefixbase}/%{fullname}
%define moduleroot      %{prefixbase}/%{name}
%define _docdir         %{_prefix}/doc
%endif
%endif
%global _compiler_load  module load %{compilertag}
%global _compiler_unload  module unload %{compilertag}

Summary: Argonne National Laboratory MPI implementation
Version: 3.1.3
Distribution: Scientific Linux
Vendor:  Basement Supercomputing
Packager: Douglas Eadline <deadline@basement-supercomuting.com>
License: BSD-like
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
URL: http://www.mcs.anl.gov/mpi/mpich/
#
# This spec file was inspired by spec files created by others for MPICH,
# including the Scyld version, written by Frederick (Rick) Niles of Scyld, and 
# included as mpich-scyld.spec in the MPICH source distribution.
#
# Spec file modified by Joe Landman for 1.2.6 with specific options
# and fixes to enable correct builds with RedHat, FCx, SuSE, ...
# placed mpich in /opt/mpich-1.2.6, and set the /etc/profile.d/mpich.*
# to point to it.a
#
# Modified by Douglas Eadline to work with BSC/Limulus framework
# Installs in /opt/mpi
#
%define other_file_systems %{nil}

# Other than gnu and intel compilers these have not been tested recently 
%if "1" == "%{use_intel}"
    %define compilertag intel 
    %define setenvs export FC=ifort;  export CC=icc; export CXX=icpc;
    %define fopts %{nil}
    %define extralibs -lirc
    %define extralibs %{nil}
    %define x86_64opts CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC"
#    %define extraldopts -L%{compiler_path}/lib -lPEPCF90 -lIEPCF90 -lF90 %{compiler_path}/lib/libintrins.a
%else
%if "1" == "%{use_pgi}"
    echo "PGI Comp not implemented"
    exit 1
%else
%if "1" == "%{use_pathsc}"
    echo "PATH Comp not implemented"
    exit 1
%else
%if "1" == "%{use_gnu3}"
    %define c_compiler gcc
    %define compilertag gnu3
    %define compiler_path /usr/bin
    %define setenvs export FC=%{compiler_path}/g77;
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define x86_64opts CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC"
%else
# Default is gnu4
    %define compilertag gnu4
    %define c_compiler gcc
    %define compiler_path /usr/bin
    %define setenvs export FC=%{compiler_path}/gfortran; 
    %define fopts %{nil}
    %define extralibs %{nil}
    %define extraldopts %{nil}
    %define x86_64opts CFLAGS="-fPIC" CXXFLAGS="-fPIC" FCFLAGS=" -fPIC"
%endif
%endif
%endif
%endif

Name: %{nbase}-%{compilertag}
Source0: mpich-%{version}.tar.gz
Patch0: mpich-omx-configure.patch
Buildroot: %{_tmppath}/%{name}-root
Requires: modules  >= 3.2.6, libxml2
Provides: libmpich.a libfmpich.a libmpichcxx.a libmpichf90.a

%define fullname %{name}-%{version}

# Define alternate root directories for installation here

%define _mandir 	%{_prefix}/man
%define _exec_prefix  	%{_prefix}/bin
%define _bindir  	%{_prefix}/bin
%ifnarch x86_64
%define _libdir  	%{_prefix}/lib
%endif
%ifarch x86_64
%define _libdir  	%{_prefix}/lib64
%endif
%define _sbindir  	%{_prefix}/sbin
%define _includedir  	%{_prefix}/include
%define _etcdir		%{_prefix}/etc
%define _exampledir	%{_prefix}/examples


#
# If these are changed, make sure that you change the directories selected 
# under the files step.

#%define prefixdir   	%{?buildroot:%{buildroot}}%{_prefix}
#%define libdir   	%{?buildroot:%{buildroot}}%{_libdir}
%define prefixdir   	%{_prefix}
%define libdir   	%{_libdir}

# Choose whether the man pages go into a common directory or an mpich one
%define mandir   	%{?buildroot:%{buildroot}}%{_mandir}

%define exec_prefix 	%{?buildroot:%{buildroot}}%{_exec_prefix}
%define bindir 		%{?buildroot:%{buildroot}}%{_bindir}
%define sbindir 	%{?buildroot:%{buildroot}}%{_sbindir}
%define example_dir     %{?buildroot:%{buildroot}}%{_exampledir}


%description 
MPICH2 is an open-source and portable implementation of the Message-Passing
Interface (MPI, www.mpi-forum.org).  MPI is a library for parallel programming,
and is available on a wide range of parallel machines, from single laptops to
massively parallel vector parallel processors.  

%prep
%setup -q -n %{nbase1}-%{version}
%if "1" == "%{as_omx}"
%patch0 -p0
%endif

%build
rpm -qf /opt/Modules/bin/modulecmd >& /dev/null
if [ $? -ne 0 ]; then
  echo "This RPM requries the BSC Modules package to build"
  exit 1
fi
. /etc/profile.d/modules.sh
# there is no module for gnu4, gnu3, these are default
# the module command just fails to load these module
# and continues with the gnu compilers, a bit ugly but it works
%{_compiler_load}

%setenvs
#make installed libs available during build
export MPICH2LIB_LDFLAGS=-L%{prefixdir}/lib64
echo " MPICH2LIB_LDFLAGS"
%if "1" == "%{as_omx}"
%define omx_libs  "--with-mx-lib=/usr/open-mx/lib"
%define omx_include "--with-mx-include=/usr/open-mx/include"
%define device "--with-device=ch3:nemesis:mx"
echo "OPENMX"
%else
%if "1" == "%{with_mx}"
%define omx_libs  "--with-mx-lib=/usr/mx/lib"
%define omx_include "--with-mx-include=/usr/mx/include"
%define device "--with-device=ch3:nemesis:mx"
echo "MX"
%else
%if "1" == "%{with_gm}"
%define omx_libs  "--with-mx-lib=/usr/gm/lib"
%define omx_include "--with-mx-include=/usr/gm/include"
%define device "--with-device=ch3:nemesis:gm"
echo "GM"
%else
%define omx_libs %{nil}
%define omx_include %{nil}
%define device "--with-device=ch3:nemesis"
%endif
%endif
%endif


%ifnarch x86_64
./configure --prefix=%{prefixdir} --enable-shared \
    --enable-fast=O3  %{device} --with-pm=hydra --enable-fast  --enable-fortran=all %{omx_libs} %{omx_include}
%endif
%ifarch x86_64
./configure --prefix=%{prefixdir} --enable-fast=O3 --enable-shared \
   --libdir=%{libdir}  %{device}  --with-pm=hydra --enable-fast --enable-fortran=all %{omx_libs} %{omx_include} %{x86_64opts}


%endif	
        
%{__make}
%{_compiler_unload}
 
%install
%setenvs
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi
echo %{buildroot}
make  DESTDIR=%{buildroot} install


FIXLIST="mpic++ mpicc mpicxx mpif77 mpif90"
for F in $FIXLIST ; do
sed 's@/usr/local/bin/bash@/bin/bash@g' %{buildroot}/%{prefixdir}/bin/$F > %{buildroot}/%{prefixdir}/bin/$F.1
sed 's@%{buildroot}@@g'  %{buildroot}/%{prefixdir}/bin/$F.1 > %{buildroot}/%{prefixdir}/bin/$F 
chmod ugo+x %{buildroot}/%{prefixdir}/bin/$F
done

# add documentation
mkdir -p  %{buildroot}/%{prefixdir}/share/www
/bin/cp -a www/*  %{buildroot}/%{prefixdir}/share/www
mkdir -p  %{buildroot}/%{prefixdir}/share/examples
/bin/cp -a examples/*  %{buildroot}/%{prefixdir}/share/examples


# create /opt/etc/ld.so.conf.d/
echo "Creating /opt/etc/ld.so.conf.d/%{name} file"
mkdir -p %{buildroot}/opt/etc/ld.so.conf.d
cat <<EOF>> %{buildroot}/opt/etc/ld.so.conf.d/%{name}-%{version}.conf
%{_libdir}/
EOF
# now make the module file
mkdir -p %{buildroot}/%{modulepath}/%{nbase}/%{version}
cat <<EOF >%{buildroot}/%{modulepath}/%{nbase}/%{version}/%{compilertag}
#%Module1.0#######################################################################
## %{nbase} modulefile
##
## Copyright (c) 2012 Basement Supercomputing

conflict %{moduleconflicts}

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing %{name} Version %{version}\n"
}

module-whatis "%{name} version %{version}"
module-log error none

set libarch lib
set arch1  x86_64
set arch2 [ exec arch ]
if {\$arch1 == \$arch2 } {
  set libarch lib64
}

set currentstring "module load %{nbase}/%{version}/%{compilertag}"
set mpiroot %{moduleroot}-%{version}

if [ module-info mode load ] {
        prepend-path  LD_LIBRARY_PATH \$mpiroot/\$libarch
        setenv MPIPATH \$mpiroot
        setenv MPICH2_HOME \$mpiroot
        append-path MANPATH \$mpiroot/share/man
        prepend-path PATH \$mpiroot/bin
}
if [ module-info mode remove ] {
        remove-path LD_LIBRARY_PATH \$mpiroot/\$libarch
        remove-path MANPATH \$mpiroot/share/man
        remove-path PATH \$mpiroot/bin
        unsetenv MPICH2_HOME
        unsetenv MPIPATH
}
EOF

%post
/sbin/ldconfig

%postun 
/sbin/ldconfig 2>/dev/null

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%doc README COPYRIGHT doc/userguide/user.pdf
%{prefixdir}
/opt/%{_sysconfdir}/ld.so.conf.d/%{name}-%{version}.conf
%{modulepath}/%{nbase}/%{version}/%{compilertag}


%changelog
* Tue Jan 27 2015  Douglas Eadline <deadline@basement-supercomputing.com>
- some clean up for MPICH V3
* Fri Dec 12 2012  Douglas Eadline <deadline@basement-supercomputing.com>
- removed node version. Better solution using /opt/etc//ld.so.conf.d/
- clean up module file
* Thu Apr 28 2011  Douglas Eadline <deadline@basement-supercomputing.com>
- clean up, made node version (just the ld.conf.d file) adjust for new version 1.3.2
* Tue Feb 13 2006  Douglas Eadline <deadline@basement-supercomputing.com>
- added examples
- made gnu{3,4}  version option
- removed -p4mpd option - did not build
- remove profile.d stuff - now use modules
- switch to spmd build so it will work with SGE
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- fixed the AMD64 bug
* Wed Jul 06 2005 Joe Landman <landman@scalableinformatics.com>
- Update to mpich2-1.0.2 with various options.
* Fri Dec 10 2004 Joe Landman <landman@scalableinformatics.com>
- Update to mpich 1.2.6 with various options.
* Fri Jan 10 2003 Willam Gropp <gropp@mcs.anl.gov>
- Update to MPICH 1.2.5 and fixed buildroot
* Thu Apr 25 2002 William Gropp <gropp@mcs.anl.gov>
- Initial version

